package klassen;

import java.io.FileNotFoundException;


public class Algorithmus{
	// Anfang Attribute
	private String bezeichnung;
	private String beschreibung;
	private String zeichenkette;
	private String sortiert;
	private int vergleiche;
	private int tausch;
	private CSVSpeicher derSpeicher = new CSVSpeicher();
	private Hauptfenster dieOberflaeche;
	private Liste dieDaten = new Liste();


	// Ende Attribute

	//Konstruktor
	public Algorithmus(Hauptfenster o){
		dieOberflaeche = o;		
	}

	public Algorithmus(){

	}

	// Getter und Setter


	public String getBezeichnung() {
		return this.bezeichnung;
	}

	public void setBezeichnung(String pBezeichnung) {
		this.bezeichnung = pBezeichnung;
	}

	public String getBeschreibung() {
		return this.beschreibung;
	}

	public void setBeschreibung(String pBeschreibung) {
		this.beschreibung = pBeschreibung;
	}

	public String getZeichenkette() {
		return this.zeichenkette;
	}

	public void setZeichenkette(String pZeichenkette) {
		this.zeichenkette = pZeichenkette;
	}

	public String getSortiert() {
		return this.sortiert;
	}

	public void setSortiert(String pSortiert) {
		this.sortiert = pSortiert;
	} 

	public void setVergleiche(int pVergleiche) {
		this.vergleiche = pVergleiche;
	} 

	public int getVergleiche() {
		return this.vergleiche;
	}

	public void setTausch(int pTausch) {
		this.tausch = pTausch;
	} 

	public int getTausch() {
		return this.tausch;
	}

	public CSVSpeicher getDerSpeicher() {
		return derSpeicher;
	}

	public void setDerSpeicher(CSVSpeicher derSpeicher) {
		this.derSpeicher = derSpeicher;
	}	

	//Sonstige Methoden

	/*Suche nach einzelnen Datenstzen im Datencontainer*/
	public void suchen(){



	}

	/*Anzeige Aller Daten auf der GUI*/
	public void anzeigen(){
		int i = 0;
		dieOberflaeche.leereAusgabe();
		while(i < dieDaten.getData().size()){
			String datensatz = dieDaten.getData().get(i);
			dieOberflaeche.schreibeDatensatz(datensatz);
			i++;
		}
	}

	/*Lesen/Importieren von Daten aus einer Datei*/
	public void importieren(){

		String mOK = derSpeicher.importieren(dieDaten);

		if(mOK.equals("ok")){
			dieOberflaeche.zeigeDialogfenster("Der Text wurde erfolgreich importiert!");
		}else{
			dieOberflaeche.zeigeDialogfenster("Fehler beim importieren!");
		}		
	}

	/*Schreiben/Exportieren von Daten aus einer Datei*/
	public void exportieren(){	
		try{
			derSpeicher.exportieren(dieDaten);
			dieOberflaeche.zeigeDialogfenster("Die Daten sind gespeichert!");

		}catch(FileNotFoundException e){
			dieOberflaeche.zeigeDialogfenster("Fehler beim Speichern!");
			e.printStackTrace();
		}
	}

	//Einfgen einzelner Datenstze
	public void einfuegen(){
		dieDaten.getData().add(this.zeichenkette);
		dieOberflaeche.zeigeDialogfenster("Die Daten wurden eingefgt!");
	}

	//Testen
	public void testen(){
		String mBezeichnung = this.getBezeichnung();

		if(mBezeichnung.equals("Daten importieren")){
			this.importieren();
			this.beschreibung="Importiert Daten aus einer CSV-Datei.";
			dieOberflaeche.schreibeAusgabe();
		}else if(mBezeichnung.equals("Daten exportieren")){
			this.exportieren();
			this.beschreibung="Exportiert Daten in eine Datei.";
			dieOberflaeche.schreibeAusgabe();
		}else if(mBezeichnung.equals("Daten anzeigen")){
			this.anzeigen();
			this.beschreibung="Gibt Daten auf der Benutzeroberflche aus.";
		}else if(mBezeichnung.equals("Daten einfgen")){
			this.einfuegen();
			this.beschreibung="Fgt Daten zu einer Datensammlung hinzu.";
		}else if(mBezeichnung.equals("Daten suchen")){
			this.suchen();
			this.beschreibung="Sucht Daten in einer Datensammlung.";
		}				
	}

}